#include BrForFolder.h

**    (c) 2002
**
** 

Define Class SH_GetFolder as Custom
	BrowseType = BIF_RETURNONLYFSDIRS + BIF_USENEWUI + BIF_EDITBOX
	FolderType = CSIDL_DESKTOP
	
	*    Caption -  CHR(13)
	*    2 ,    BIF_USENEWUI - 3 
	Caption = " "

	*      BrowseFolders
	SelectedFolder = ""

	Procedure Init
		Declare Long CoTaskMemAlloc in ole32.dll Long nBytes
		Declare CoTaskMemFree in ole32.dll Long hMem
		Declare Long lstrcpy in Kernel32.dll Long lpString1, String @ lpString2
		Declare Long SHBrowseForFolder in Shell32.dll String @ BrowseInfo
		Declare Long SHGetPathFromIDList in Shell32.dll Long pidList, String @ lpBuffer
		Declare Long SHGetSpecialFolderLocation in Shell32.dll Long hWndOwner, Long nFolder, Long @ ListId
	EndProc
	
	#If Version(5)>=700
		*   6   - !!!
		*      Clear Dlls,  (!)
		*    DLL-.    
		*      DLL ( ),
		*    ,    , 
		*     .    VFP >7.0
		*     DLL ,    #if ...
		Function Destroy
			Clear Dlls "CoTaskMemAlloc", "CoTaskMemFree", "lstrcpy", ;
				"SHBrowseForFolder", "SHGetPathFromIDList", ;
				"SHGetSpecialFolderLocation"
		EndFunc
	#EndIf


	*   
	*   : BrowseFolders([hWndOwner, [sMessage, [BrowseT, [RootFolder]]])
	*     	hWndOwner		Handle  
	*			sMessage			,      
	*			BrowseT			 BIF_*  (. BrForFolder.h)
	*			RootFolder		   CSIDL_* (. BrForFolder.h)
	*
	*       ,  ""    
	Function BrowseFolders
	Lparameters hWndOwner, sMessage, BrowseT, RootFolder
	
		If Vartype(hWndOwner) # "N"
			#If Version(5)>=700
				hWndOwner = _Screen.HWnd
			#Else
				Declare Long GetForegroundWindow in Win32API
				hWndOwner = GetForegroundWindow()
			#EndIf
		EndIf
		If Vartype(sMessage) # "C"
			sMessage = This.Caption
		EndIf
		If Vartype(BrowseT) # "N"
			BrowseT = This.BrowseType
		EndIf
		If Vartype(RootFolder) # "N"
			RootFolder = This.FolderType
		EndIf

		Local Nullpos, lpIDList, res, sPath, sMessBufer, RootID, pIDLRoot, ;
			ulFlags, pszDisplayName, lpfnCallback, _lParam, iImage, lpszTitle

		Store 0 to Nullpos, lpIDList, res, RootID, pIDLRoot, pszDisplayName, ;
			lpfnCallback, _lParam, iImage

		Store "" to sPath, BInfo

		*  RootID  SHBrowseForFolder
		SHGetSpecialFolderLocation(hWndOwner, RootFolder, @RootID)

		sMessage = Alltrim(sMessage)+Chr(0)				&& ,  sMessage  Zero Terminating String

		lpszTitle = CoTaskMemAlloc(Len(sMessage)+2)	&&     ( +2 )
		lpszTitle = lstrcpy(lpszTitle,@sMessage)

		ulFlags = BrowseT
		If RootID # 0 
			pIDLRoot = RootID
		EndIf

		*  BrowseInfo
		BInfo = ;
			This.Num2HexLong(hWndOwner)+;
			This.Num2HexLong(pIDLRoot)+;
			This.Num2HexLong(pszDisplayName)+;
			This.Num2HexLong(lpszTitle)+;
			This.Num2HexLong(ulFlags)+;
			This.Num2HexLong(lpfnCallback)+;
			This.Num2HexLong(_lParam)+;
			This.Num2HexLong(iImage)

		lpIDList = SHBrowseForFolder(@BInfo)
		If lpIDList # 0
			sPath = Replicate(Chr(0),MAX_PATH)
			res = SHGetPathFromIDList(lpIDList, @sPath)
			CoTaskMemFree(lpIDList)
			Nullpos = At(Chr(0),sPath)
			If Nullpos # 0
				sPath = Left(sPath, Nullpos - 1)
			Else
				sPath = ""
			EndIf
		EndIf

		CoTaskMemFree(lpszTitle)
		This.SelectedFolder = sPath
		Return sPath
	EndFunc



	*     
	* (4  - : LONG)
	*
	*   : nNum    0..4294967295
	*
	*     , 
	*          LONG
	
	Hidden function Num2HexLong
	Lparameters nNum
		Return Chr(Bitand(nNum,0x000000FF))+;
			Chr(BitRShift(Bitand(nNum,0x0000FF00),1*8))+;
			Chr(BitRShift(Bitand(nNum,0x00FF0000),2*8))+;
			Chr(BitRShift(Bitand(nNum,0xFF000000),3*8))
	EndFunc

EndDefine


